﻿using PdfSharp.Pdf;
using PdfSharp.Pdf.AcroForms;
using PdfSharp.Pdf.IO;

namespace FillForm
{
    class Program
    {
        static void Main(string[] args)
        {
            string filename = @"C:\pdf\BE_Birth_DE_BG.pdf";
            PdfDocument doc = PdfReader.Open(filename, PdfDocumentOpenMode.Modify);
            PdfSharp.Pdf.AcroForms.PdfAcroForm acroForm = doc.AcroForm;

            //setting NeedAppearances to true blocks checkboxes, it's impossible to check them
            //even previously checked checkboxes get unchecked
            bool needAppearances = true;
            if (acroForm.Elements.ContainsKey("/NeedAppearances"))
            {
                acroForm.Elements["/NeedAppearances"] = new PdfBoolean(needAppearances);
            }
            else
            {
                acroForm.Elements.Add("/NeedAppearances", new PdfBoolean(needAppearances));
            }

            PdfTextField textField = (PdfTextField)acroForm.Fields["text_71"];
            PdfString s = new PdfString("ABCDE");
            textField.Value = s;

            PdfCheckBoxField checkboxField = (PdfCheckBoxField)acroForm.Fields["checkbox_100"];
            checkboxField.Checked = true;//does not work when NeedApppearances is true

            doc.Save(filename);
        }
    }
}
